﻿using System;
using System.Collections.Generic;
using System.Data.Entity.Infrastructure;
using System.Linq;

using SampleApp.Business.Crud.Validators;
using SampleApp.Business.Exceptions;
using SampleApp.Common.Extensions;
using SampleApp.Data.Common;
using SampleApp.Data.Context;
using SampleApp.Data.Exceptions;
using SampleApp.Data.SampleAppEntities;

namespace SampleApp.Business.Crud.Common
{
    internal abstract class CommandOperationBase
    {
        protected bool HandleDbException(Exception exception, object entity)
        {
            if (exception is DbUpdateConcurrencyException)
                return false;

            var message = "Failed to process entity {0}.".InvariantFormat(entity);
            throw new SampleAppBusinessException(message, exception);
        }

        protected virtual void ValidateDto(object dto, SampleAppContext context, DataValidationResult validationResult)
        {
        }
    }
}
