using System;
using System.Collections.Generic;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Linq.Dynamic;
using System.Linq.Expressions;

using SampleApp.Business.Crud.Common;
using SampleApp.Business.Crud.Validators;
using SampleApp.Common.Extensions;
using SampleApp.Data.Common;
using SampleApp.Data.SampleAppEntities;

namespace SampleApp.Business.Crud
{
    internal interface IPersonUpdateOperation : IUpdateEntityOperation<Person> { }

    internal class PersonUpdateOperation : UpdateEntityOperationBase<Person>, IPersonUpdateOperation
    {
        public PersonUpdateOperation(IEnumerable<IEntityValidator<Person>> validators)
            : base(validators)
        {
        }

        protected override void SetUpdateableProperties(DbEntityEntry<Person> entry)
        {
            // Don't misuse this method for manipulation with entities
            // other than setting .IsModified = true
            // We implement it here, because EF doesn't have better approach
            // for this if we want to use typed labmda expressions
            SetModified(
                entry,
                x => x.LastName,
                x => x.FirstName,
                x => x.MiddleName,
                x => x.Title);
        }
    }
}