﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SampleApp.Business.Crud.Common;
using SampleApp.Common.Interfaces;
using SampleApp.Data.Context;
using SampleApp.Data.SampleAppEntities;

namespace SampleApp.Business.Crud
{
    public interface IPersonsCommandFacade : ICommandFacade, IService { }

    internal class PersonsCommandFacade : CommandFacadeBase<Person>, IPersonsCommandFacade
    {
        public PersonsCommandFacade(
            ISampleAppContextFactory contextFactory,
            ICreateEntityOperation<Person> createOperation,
            IPersonUpdateOperation updateOperation,
            IDeleteEntityOperation<Person> deleteOperation)
            : base(contextFactory, createOperation, updateOperation, deleteOperation)
        {
        }
    }
}
