using SampleApp.Data.Common;
using SampleApp.Data.SampleAppEntities;

namespace SampleApp.Business.Crud.Validators
{
    internal abstract class ValidatorBase<TEntity> : IEntityValidator<TEntity>
    {
        public virtual void ValidateNew(TEntity entity, SampleAppContext context, DataValidationResult validationResult)
        {
        }

        public virtual void ValidateUpdate(TEntity entity, SampleAppContext context, DataValidationResult validationResult)
        {
        }

        public virtual void ValidateDelete(int id, SampleAppContext context, DataValidationResult validationResult)
        {
        }
    }
}