﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using AutoMapper;

using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.Data.SampleAppEntities;

namespace SampleApp.Business.DataTransferObjects.Mapping
{
    internal class PersonMappingProfile : Profile
    {
        protected override void Configure()
        {
            CreateMap<Person, ViewPersonDto>();
            CreateMap<Person, EditPersonDto>();
            CreateMap<EditPersonDto, Person>()
                .ForMember(dest => dest.CreatedAt, opts => opts.Ignore())
                .ForMember(dest => dest.CreatedBy, opts => opts.Ignore())
                .ForMember(dest => dest.ModifiedAt, opts => opts.Ignore())
                .ForMember(dest => dest.ModifiedBy, opts => opts.Ignore())
                .ForMember(dest => dest.EmailAddresses, opts => opts.Ignore());
        }
    }
}
