using System;
using System.Collections.Generic;
using System.Linq;

using AutoMapper;
using AutoMapper.QueryableExtensions;

using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.Data.Context;

namespace SampleApp.Business.Queries
{
    public interface IEditPersonQuery : IQuery<EditPersonDto> { }

    internal class EditPersonQuery : QueryBase<EditPersonDto>, IEditPersonQuery
    {
        public EditPersonQuery(ISampleAppContextFactory contextFactory)
            : base(contextFactory)
        {
        }

        protected override IQueryable<EditPersonDto> GetQuery()
        {
            // this would load entire table into memory: !!!
            // return Mapper.Map<IQueryable<EditPersonDto>>(Context.People);

            // better - construct expression - EF will then generate SQL
            return Context.People.UseAsDataSource().For<EditPersonDto>();
        }
    }
}