﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using EntityFramework.Extensions;

using SampleApp.Common.Interfaces;

namespace SampleApp.Business.Queries
{
    public interface IQuery<TDto> : IService
       where TDto : class
    {
        IEnumerable<TDto> GetAll(Func<IQueryable<TDto>, IQueryable<TDto>> queryExtensionFunc);

        TDto GetOne(int id);
    }
}
