﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using AutoMapper.QueryableExtensions;

using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.Data.Context;

namespace SampleApp.Business.Queries
{
    public interface IViewPersonsQuery : IQuery<ViewPersonDto> { }

    internal class ViewPersonsQuery : QueryBase<ViewPersonDto>, IViewPersonsQuery
    {
        public ViewPersonsQuery(ISampleAppContextFactory contextFactory)
            : base(contextFactory)
        {
        }

        protected override IQueryable<ViewPersonDto> GetQuery()
        {
            // this would load entire table into memory: !!!
            // return Mapper.Map<IQueryable<EditPersonDto>>(Context.People);

            // better - construct expression - EF will then generate SQL

            return Context.People.UseAsDataSource().For<ViewPersonDto>();
        }
    }
}
