﻿using System.Collections.Generic;
using System.Linq;

namespace SampleApp.Common.Extensions
{
    public static class CollectionExtensions
    {
        /// <summary>
        /// Is the this object in the <paramref name="collection"/> collection?
        /// </summary>
        /// <typeparam name="T">collection type</typeparam>
        /// <param name="instance">
        /// instance to be compared
        /// </param>
        /// <param name="collection">
        /// collection of items, where any is searched for equality
        /// </param>
        public static bool In<T>(this T instance, params T[] collection)
        {
            return collection != null && collection.Contains(instance);
        }

        /// <summary>
        /// Is the this object in the <paramref name="collection"/> collection?
        /// </summary>
        /// <typeparam name="T">collection type</typeparam>
        /// <param name="instance">
        /// instance to be compared
        /// </param>
        /// <param name="collection">
        /// collection of items, where any is searched for equality
        /// </param>
        public static bool In<T>(this T instance, IEnumerable<T> collection)
        {
            return collection != null && collection.Contains(instance);
        }
    }
}
