﻿using System;
using System.Diagnostics.CodeAnalysis;
using System.Linq;

using AutoMapper;

using Castle.Facilities.TypedFactory;
using Castle.MicroKernel.Registration;
using Castle.MicroKernel.SubSystems.Configuration;
using Castle.Windsor;

using SampleApp.Common.Interfaces;

namespace SampleApp.Common.Infrastructure
{
    public class CommonWindsorInstaller : IWindsorInstaller
    {
        [SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1116:SplitParametersMustStartOnLineAfterDeclaration", Justification = "Reviewed. Suppression is OK here."), SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1118:ParameterMustNotSpanMultipleLines", Justification = "Reviewed. Suppression is OK here."), SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1118:ParameterMustNotSpanMultipleLines", Justification = "Reviewed. Suppression is OK here."), SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1115:ParameterMustFollowComma", Justification = "Reviewed. Suppression is OK here."), SuppressMessage("StyleCop.CSharp.ReadabilityRules", "SA1115:ParameterMustFollowComma", Justification = "Reviewed. Suppression is OK here.")]
        public void Install(IWindsorContainer container, IConfigurationStore store)
        {
            if (container == null)
                throw new ArgumentNullException("container");

            if (store == null)
                throw new ArgumentNullException("store");

            container.Register(
                Classes.FromThisAssembly()
                .IncludeNonPublicTypes()
                .BasedOn<IService>()
                .WithServiceAllInterfaces()
                .WithServiceSelf()
                .AllowMultipleMatches(),

                Classes.FromThisAssembly()
                .IncludeNonPublicTypes()
                .BasedOn<Profile>()
                .WithServiceBase()
                .AllowMultipleMatches());
        }
    }
}