﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SampleApp.Common.Infrastructure.Operations;
using SampleApp.Common.Interfaces;

namespace SampleApp.Common.Infrastructure
{
    public interface IDateTimeFacade : IService
    {
        DateTime GetCurrent();
    }

    internal class DateTimeFacade : IDateTimeFacade
    {
        private readonly IDateTimeOperation _dateTimeOperation;

        public DateTimeFacade(IDateTimeOperation dateTimeOperation)
        {
            _dateTimeOperation = dateTimeOperation;
        }

        public DateTime GetCurrent()
        {
            return _dateTimeOperation.GetCurrent();
        }
    }
}
