using System;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Linq;

using SampleApp.Common.Authentication;
using SampleApp.Common.Infrastructure;

namespace SampleApp.Data.SampleAppEntities
{
    public partial class SampleAppContext : DbContext
    {
        private readonly IDateTimeFacade _dateTimeFacade;

        private readonly IAuthenticationService _authenticationService;

        public SampleAppContext(IDateTimeFacade dateTimeFacade, IAuthenticationService authenticationService)
            : base("name=SampleAppEntities")
        {
            _dateTimeFacade = dateTimeFacade;
            _authenticationService = authenticationService;
            Configuration.ValidateOnSaveEnabled = false;
            Configuration.LazyLoadingEnabled = false;
        }

        public DbSet<EmailAddress> EmailAddresses { get; set; }
        public DbSet<LogLine> LogLines { get; set; }
        public DbSet<Person> People { get; set; }
        public DbSet<TestItem> TestItems { get; set; }
    }
}
