﻿CREATE TABLE [dbo].[EmailAddress] (
    [Id]           INT              IDENTITY (1, 1) NOT NULL,
    [PersonId]     INT              NOT NULL,
    [EmailAddress] NVARCHAR (50)    COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
    [RowGuid]      UNIQUEIDENTIFIER NOT NULL,
    [CreatedAt]    DATETIME2 (7)    NOT NULL,
    [CreatedBy]    VARCHAR (50)     NOT NULL,
    [ModifiedAt]   DATETIME2 (7)    NULL,
    [ModifiedBy]   VARCHAR (50)     NULL,
    CONSTRAINT [PK_EmailAddress] PRIMARY KEY CLUSTERED ([Id] ASC),
    CONSTRAINT [FK_EmailAddress_Person] FOREIGN KEY ([PersonId]) REFERENCES [dbo].[Person] ([Id]),
    CONSTRAINT [UK_EmailAddress_RowGuid] UNIQUE NONCLUSTERED ([RowGuid] ASC)
);


GO
CREATE NONCLUSTERED INDEX [IX_EmailAddress_PersonId]
    ON [dbo].[EmailAddress]([PersonId] ASC);

