﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;

using SampleApp.Common.Authentication;

namespace SampleApp.TestUtilities
{
    public class MockAuthenticationService : IAuthenticationService
    {
        private IPrincipal _currentUser;
        public IPrincipal CurrentUser
        {
            get
            {
                if (_currentUser == null)
                    SetCurrentUserName("test user" + new Random().Next());
                return _currentUser;
            }
        }

        public void SetCurrentUserName(string username)
        {
            _currentUser = new GenericPrincipal(new GenericIdentity(username), new string[0]);
        }
    }
}
