﻿using System;
using System.Collections.Generic;
using System.Linq;

using Castle.MicroKernel.Registration;
using Castle.Windsor;

using SampleApp.Common.Infrastructure;

namespace SampleApp.TestUtilities
{
    public abstract class WindsorTestsBase : IDisposable
    {
        private WindsorContainer _container;
        protected WindsorTestsBase()
        {
            _container = new WindsorContainer();
            _container.Install(GetInstallers().ToArray());
            WindsorStore.CurrentContainer = _container;
        }

        ~WindsorTestsBase()
        {
            Dispose(false);
        }

        private bool IsDisposed { get; set; }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected abstract IEnumerable<IWindsorInstaller> GetInstallers();

        protected virtual void Dispose(bool disposing)
        {
            if (!IsDisposed)
            {
                IsDisposed = true;
                if (disposing)
                {
                    _container.Dispose();
                    _container = null;
                }
            }
        }
    }
}