﻿using System;
using System.Collections.Generic;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using SampleApp.Business.Crud;
using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.Business.Queries;
using SampleApp.WebUI.Controllers;

namespace SampleApp.WebUI.Areas.Persons.Controllers
{
    // here we don't have view-specific model, we use EditPersonDto on UI
    // It isn't recommended, but it's acceptable, unless you need view-specific properties or mapping for UI
    public class PersonController : CommandControllerBase<EditPersonDto, EditPersonDto>
    {
        public PersonController(IPersonsCommandFacade commandFacade, IEditPersonQuery detailsQuery)
            : base(detailsQuery, commandFacade)
        {
        }
    }
}