﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.Business.Queries;
using SampleApp.WebUI.Areas.Persons.Models;
using SampleApp.WebUI.Controllers;

namespace SampleApp.WebUI.Areas.Persons.Controllers
{
    public class PersonListController : GridListControllerBase<ViewPersonDto, PersonViewModel>
    {
        public PersonListController(IQuery<ViewPersonDto> query)
            : base(query)
        {
        }

        protected override IQueryable<ViewPersonDto> BuildListQuery(IQueryable<ViewPersonDto> dtoSource)
        {
            return dtoSource
                .Where(person => person.LastName != "Jobs")
                .OrderByDescending(p => p.Id)
                .Take(20);
        }
    }
}