﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using AutoMapper;

using SampleApp.Business.DataTransferObjects.Persons;
using SampleApp.WebUI.Areas.Persons.Models;

namespace SampleApp.WebUI.Areas.Persons.Mapping
{
    internal class PersonsMappingProfile : Profile
    {
        protected override void Configure()
        {
            CreateMap<ViewPersonDto, PersonViewModel>()
                .ForMember(
                    dest => dest.DisplayName,
                    opts => opts.MapFrom(src => string.Format("{0}, {1} {2} {3}", src.LastName, src.FirstName, src.MiddleName, src.Title)));
        }
    }
}