﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Web;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;

using Castle.MicroKernel.Lifestyle;

using log4net;

using SampleApp.Common.Extensions;
using SampleApp.Common.Infrastructure;
using SampleApp.Data.Context;

namespace SampleApp.WebUI
{
    public class SampleApplication : HttpApplication
    {
        private static readonly ILog Logger = LogManager.GetLogger(typeof(SampleApplication));

        protected void Application_Start()
        {
            LoggingConfig.ConfigureLog4Net();
            AppDomain.CurrentDomain.UnhandledException += OnUnhandledException;
            
            var container = WindsorConfig.InitializeContainer();

            AreaRegistration.RegisterAllAreas();
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);

            AutoMapperConfig.Configure();
        }

        private static void OnUnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            var message = "Unhandled exception from thread {0}({1}).\r\n{2}"
                .InvariantFormat(Thread.CurrentThread.ManagedThreadId, Thread.CurrentThread.Name, e.ExceptionObject);
            Logger.Error(message);
        }
    }
}
