﻿using System;
using System.Collections;
using System.Data.Entity;
using System.Data.Entity.Migrations;
using System.Data.Entity.Validation;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;

using Moq;

using SampleApp.Common.Authentication;
using SampleApp.Common.Infrastructure;
using SampleApp.Data.SampleAppEntities;

using Xunit;

namespace SampleApp.Data.Tests
{
    public class DemoTests : BusinessTestsBase
    {
        [Fact]
        public void Test1()
        {
            var dateFacade = new Mock<IDateTimeFacade>();
            dateFacade.Setup(x => x.GetCurrent()).Returns(DateTime.Now);
            var authService = new Mock<IAuthenticationService>();
            authService.Setup(x => x.CurrentUser).Returns(new GenericPrincipal(new GenericIdentity("Test user"), null));

            using (var context = new SampleAppContext(dateFacade.Object, authService.Object))
            {
                //context.LogLines.Add(new LogLine() { Message = "x", Message2 = "yyyyyy" });
                //context.People.Add(new Person());
                var entity1 = context.People.First();
                var entity = new Person() { Id = entity1.Id };
                var entry = context.Entry(entity);
                context.Set<Person>().Local.Clear();
                //context.People.cl
                    //Add(entity);
                //entry.State = EntityState.Added;
                entry.State = EntityState.Unchanged;
                entity.FirstName = "asdX";
                entity.CreatedBy = null;

                
                var mod1 = entry.Property(x => x.FirstName).IsModified;
                var mod2 = entry.Property(x => x.CreatedBy).IsModified;
                try
                {
                    context.SaveChanges();
                }
                catch (DbEntityValidationException ex)
                {
                    var errors = ex.EntityValidationErrors.ToArray();
                }
            }
        }

        [Fact]
        public void Test2()
        {
            var dateFacade = new Mock<IDateTimeFacade>();
            dateFacade.Setup(x => x.GetCurrent()).Returns(DateTime.Now);
            var authService = new Mock<IAuthenticationService>();
            authService.Setup(x => x.CurrentUser).Returns(new GenericPrincipal(new GenericIdentity("Test user"), null));
            using (var context = new SampleAppContext(dateFacade.Object, authService.Object))
            {
                var line1 = new LogLine() { Message = "a", Message2 = "b" };
                context.LogLines.Add(line1);
                context.SaveChanges();

                var line11 = context.LogLines.OrderByDescending(x => x.Id).First();
                line11.Message = "x";
                line11.Message = "a";
                line11.Message2 += "y";
                context.SaveChanges();

            }
        }
    }
}
