using System;
using System.Collections.Generic;

using Castle.MicroKernel.Registration;

using SampleApp.Business.Infrastructure.Windsor;
using SampleApp.Common.Infrastructure;
using SampleApp.Data.Infrastructure.Windsor;
using SampleApp.Demo.Tests;
using SampleApp.TestUtilities;

namespace SampleApp.Demo.Tests
{
    public abstract class DemoTestsBase : DatabaseTestsBase
    {
        protected override IEnumerable<IWindsorInstaller> GetInstallers()
        {
            return new IWindsorInstaller[]
                       {
                           new CommonWindsorInstaller(),
                           new DataWindsorInstaller(),
                           new BusinessWindsorInstaller(),
                           new DemoTestsInstaller()
                       };
        }
    }
}